From 70e707460a76fff8bd879f1d9f554f2fa94bfdb7 Mon Sep 17 00:00:00 2001
From: Sascha Wildner <saw@online.de>
Date: Thu, 17 Nov 2016 21:49:01 +0100
Subject: [PATCH] WIP ACPICA 20161117

---
 sys/contrib/dev/acpica/changes.txt                 |   79 ++
 sys/contrib/dev/acpica/source/common/acfileio.c    |   24 +-
 sys/contrib/dev/acpica/source/common/dmtbdump.c    |  184 ++--
 sys/contrib/dev/acpica/source/common/dmtbinfo.c    |   28 +-
 sys/contrib/dev/acpica/source/compiler/aslbtypes.c |    1 -
 .../dev/acpica/source/compiler/aslcompiler.l       |   16 +-
 sys/contrib/dev/acpica/source/compiler/aslcstyle.y |   42 +-
 .../dev/acpica/source/compiler/aslexternal.c       |   15 +
 .../dev/acpica/source/compiler/aslkeywords.y       |   15 +-
 .../dev/acpica/source/compiler/aslopcodes.c        |   10 +-
 .../dev/acpica/source/compiler/aslprimaries.y      | 1021 ++++++++++++--------
 .../dev/acpica/source/compiler/aslresources.y      |  365 ++++---
 .../dev/acpica/source/compiler/aslrestype2.c       |    5 +
 sys/contrib/dev/acpica/source/compiler/aslrules.y  |  161 +--
 sys/contrib/dev/acpica/source/compiler/aslstubs.c  |    3 +-
 sys/contrib/dev/acpica/source/compiler/asltokens.y |    3 +
 sys/contrib/dev/acpica/source/compiler/asltypes.y  |    7 +-
 sys/contrib/dev/acpica/source/compiler/aslwalks.c  |   13 +-
 sys/contrib/dev/acpica/source/compiler/dttable.c   |   70 +-
 .../source/components/disassembler/dmbuffer.c      |   27 +-
 .../source/components/disassembler/dmcstyle.c      |  348 ++++---
 .../source/components/disassembler/dmresrc.c       |   30 +-
 .../acpica/source/components/dispatcher/dsinit.c   |   10 +-
 .../acpica/source/components/dispatcher/dsmethod.c |   50 +-
 .../acpica/source/components/dispatcher/dsopcode.c |    2 +-
 .../acpica/source/components/dispatcher/dswload2.c |   17 +-
 .../dev/acpica/source/components/events/evrgnini.c |   57 +-
 .../acpica/source/components/executer/exconfig.c   |   40 +-
 .../acpica/source/components/executer/exconvrt.c   |    1 -
 .../acpica/source/components/executer/exresop.c    |    1 -
 .../acpica/source/components/namespace/nsload.c    |    2 +
 .../acpica/source/components/namespace/nsnames.c   |   52 +
 .../acpica/source/components/namespace/nsxfname.c  |   42 +-
 .../dev/acpica/source/components/parser/psargs.c   |   77 +-
 .../dev/acpica/source/components/parser/psloop.c   |    3 +
 .../dev/acpica/source/components/parser/psobject.c |    8 +-
 .../dev/acpica/source/components/parser/pstree.c   |   10 +-
 .../dev/acpica/source/components/tables/tbdata.c   |   86 +-
 .../dev/acpica/source/components/tables/tbfadt.c   |   23 +-
 .../dev/acpica/source/components/tables/tbutils.c  |   96 ++
 .../dev/acpica/source/components/tables/tbxface.c  |  133 ++-
 .../dev/acpica/source/components/tables/tbxfload.c |   35 +-
 .../acpica/source/components/utilities/utdecode.c  |   54 ++
 .../acpica/source/components/utilities/utresrc.c   |   19 +-
 sys/contrib/dev/acpica/source/include/acdisasm.h   |    5 +-
 sys/contrib/dev/acpica/source/include/acevents.h   |    3 +-
 sys/contrib/dev/acpica/source/include/acnamesp.h   |    5 +
 sys/contrib/dev/acpica/source/include/acopcode.h   |   22 +-
 sys/contrib/dev/acpica/source/include/acpixf.h     |    7 +-
 sys/contrib/dev/acpica/source/include/actables.h   |   14 +-
 sys/contrib/dev/acpica/source/include/actbl.h      |  165 ++--
 sys/contrib/dev/acpica/source/include/acutils.h    |    4 +
 sys/contrib/dev/acpica/source/include/amlcode.h    |   22 +-
 .../dev/acpica/source/tools/acpibin/abcompare.c    |    9 +-
 .../dev/acpica/source/tools/acpibin/abmain.c       |   17 +-
 .../dev/acpica/source/tools/acpibin/acpibin.h      |    2 +
 .../dev/acpica/source/tools/acpinames/anstubs.c    |    3 +-
 .../acpica/source/tools/acpixtract/acpixtract.c    |    6 +-
 .../dev/acpica/source/tools/acpixtract/axutils.c   |    6 +-
 usr.sbin/acpi/acpibin/acpibin.8                    |    8 +-
 60 files changed, 2213 insertions(+), 1370 deletions(-)

diff --git a/sys/contrib/dev/acpica/source/common/acfileio.c b/sys/contrib/dev/acpica/source/common/acfileio.c
index 409e16f..ffa23a6 100644
--- a/sys/contrib/dev/acpica/source/common/acfileio.c
+++ b/sys/contrib/dev/acpica/source/common/acfileio.c
@@ -112,7 +112,7 @@ AcGetAllTablesFromFile (
     if (FileSize == ACPI_UINT32_MAX)
     {
         Status = AE_ERROR;
-        goto ErrorExit;
+        goto Exit;
     }
 
     fprintf (stderr,
@@ -124,7 +124,7 @@ AcGetAllTablesFromFile (
     if (FileSize < sizeof (ACPI_TABLE_HEADER))
     {
         Status = AE_BAD_HEADER;
-        goto ErrorExit;
+        goto Exit;
     }
 
     /* Check for an non-binary file */
@@ -134,7 +134,8 @@ AcGetAllTablesFromFile (
         fprintf (stderr,
             "    %s: File does not appear to contain a valid AML table\n",
             Filename);
-        return (AE_TYPE);
+        Status = AE_TYPE;
+        goto Exit;
     }
 
     /* Read all tables within the file */
@@ -153,23 +154,31 @@ AcGetAllTablesFromFile (
         }
         else if (Status == AE_TYPE)
         {
-            return (AE_OK);
+            Status = AE_OK;
+            goto Exit;
         }
         else if (ACPI_FAILURE (Status))
         {
-            goto ErrorExit;
+            goto Exit;
         }
 
         /* Print table header for iASL/disassembler only */
 
 #ifdef ACPI_ASL_COMPILER
 
-            AcpiTbPrintTableHeader (0, Table);
+        AcpiTbPrintTableHeader (0, Table);
 #endif
 
         /* Allocate and link a table descriptor */
 
         TableDesc = AcpiOsAllocate (sizeof (ACPI_NEW_TABLE_DESC));
+        if (!TableDesc)
+        {
+            AcpiOsFree (Table);
+            Status = AE_NO_MEMORY;
+            goto Exit;
+        }
+
         TableDesc->Table = Table;
         TableDesc->Next = NULL;
 
@@ -204,7 +213,7 @@ AcGetAllTablesFromFile (
         *ReturnListHead = ListHead;
     }
 
-ErrorExit:
+Exit:
     fclose(File);
     return (Status);
 }
@@ -262,7 +271,6 @@ AcGetOneTableFromFile (
         return (Status);
     }
 
-
     if (GetOnlyAmlTables)
     {
         /*
diff --git a/sys/contrib/dev/acpica/source/common/dmtbdump.c b/sys/contrib/dev/acpica/source/common/dmtbdump.c
index 4ef670d..789256c 100644
--- a/sys/contrib/dev/acpica/source/common/dmtbdump.c
+++ b/sys/contrib/dev/acpica/source/common/dmtbdump.c
@@ -52,31 +52,12 @@
         ACPI_MODULE_NAME    ("dmtbdump")
 
 
-/* Table of revision-dependent FADT sizes */
+/* Local prototypes */
 
-static const UINT32         FadtRevisionLength [ACPI_FADT_MAX_VERSION + 1] =
-{
-    0,                      /* 0 - illegal */
-    ACPI_FADT_V1_SIZE,      /* 1 - ACPI 1.0 */
-    0,                      /* 2 - illegal */
-    ACPI_FADT_V3_SIZE,      /* 3 - ACPI 2.0 */
-    ACPI_FADT_V4_SIZE,      /* 4 - ACPI 3.0 and ACPI 4.0 */
-    ACPI_FADT_V5_SIZE,      /* 5 - ACPI 5.0 */
-    ACPI_FADT_V6_SIZE       /* 6 - ACPI 6.0 */
-};
-
-/* Table of revision-dependent FADT info tables */
-
-ACPI_DMTABLE_INFO           *FadtRevisionInfo [ACPI_FADT_MAX_VERSION + 1] =
-{
-    NULL,                   /* 0 - illegal */
-    AcpiDmTableInfoFadt1,   /* 1 - ACPI 1.0 */
-    NULL,                   /* 2 - illegal */
-    AcpiDmTableInfoFadt3,   /* 3 - ACPI 2.0 */
-    AcpiDmTableInfoFadt4,   /* 4 - ACPI 3.0 and ACPI 4.0 */
-    AcpiDmTableInfoFadt5,   /* 5 - ACPI 5.0 */
-    AcpiDmTableInfoFadt6    /* 6 - ACPI 6.0 */
-};
+static void
+AcpiDmValidateFadtLength (
+    UINT32                  Revision,
+    UINT32                  Length);
 
 
 /*******************************************************************************
@@ -366,11 +347,6 @@ AcpiDmDumpXsdt (
  *
  * DESCRIPTION: Format the contents of a FADT
  *
- *              Check the FADT revision against the expected table length for
- *              that revision. Issue a warning if the length is not what was
- *              expected. This seems to be such a common BIOS bug that the
- *              FADT revision has been rendered virtually meaningless.
- *
  * NOTE:        We cannot depend on the FADT version to indicate the actual
  *              contents of the FADT because of BIOS bugs. The table length
  *              is the only reliable indicator.
@@ -382,72 +358,142 @@ AcpiDmDumpFadt (
     ACPI_TABLE_HEADER       *Table)
 {
     ACPI_STATUS             Status;
-    UINT8                   FadtRevision;
-    UINT32                  ExpectedLength;
-    UINT32                  i;
-
 
-    FadtRevision = Table->Revision;
 
-    /* FADT revision/length validation */
+    /* Always dump the minimum FADT revision 1 fields (ACPI 1.0) */
 
-    if ((FadtRevision == 0) ||
-        (FadtRevision == 2))
+    Status = AcpiDmDumpTable (Table->Length, 0, Table, 0,
+        AcpiDmTableInfoFadt1);
+    if (ACPI_FAILURE (Status))
     {
-        AcpiOsPrintf (
-            "// ACPI Warning: Invalid or unsupported FADT revision: %u\n",
-            FadtRevision);
         return;
     }
 
-    if (FadtRevision > ACPI_FADT_MAX_VERSION)
-    {
-        AcpiOsPrintf ("// ACPI Warning: Revision %u is not fully supported, "
-            "disassembling known fields (up to revision %u)\n\n",
-            FadtRevision, ACPI_FADT_MAX_VERSION);
-    }
-    else
+    /* Check for FADT revision 2 fields (ACPI 1.0B MS extensions) */
+
+    if ((Table->Length > ACPI_FADT_V1_SIZE) &&
+        (Table->Length <= ACPI_FADT_V2_SIZE))
     {
-        ExpectedLength = FadtRevisionLength[FadtRevision];
-        if (Table->Length != ExpectedLength)
+        Status = AcpiDmDumpTable (Table->Length, 0, Table, 0,
+            AcpiDmTableInfoFadt2);
+        if (ACPI_FAILURE (Status))
         {
-            AcpiOsPrintf (
-                "// ACPI Warning: Input FADT revision %X does not match "
-                "expected length: found 0x%X expected 0x%X\n",
-                FadtRevision, Table->Length, ExpectedLength);
+            return;
         }
     }
 
-    /*
-     * Dump the input table on a per-version basis, but is actually
-     * based upon the length of the table. Table length must
-     * be larger than the required length of the previous version.
-     */
-    for (i = 1; i <= ACPI_FADT_MAX_VERSION; i++)
+    /* Check for FADT revision 3/4 fields and up (ACPI 2.0+ extended data) */
+
+    else if (Table->Length > ACPI_FADT_V2_SIZE)
     {
-        if (!FadtRevisionLength[i]) /* Skip any empty slots */
+        Status = AcpiDmDumpTable (Table->Length, 0, Table, 0,
+            AcpiDmTableInfoFadt3);
+        if (ACPI_FAILURE (Status))
         {
-            continue;
+            return;
         }
 
-        /* Dump the fields specific to FADT revision[i] */
+        /* Check for FADT revision 5 fields and up (ACPI 5.0+) */
 
-        Status = AcpiDmDumpTable (Table->Length, 0, Table, 0,
-            FadtRevisionInfo[i]);
-        if (ACPI_FAILURE (Status))
+        if (Table->Length > ACPI_FADT_V3_SIZE)
         {
-            return;
+            Status = AcpiDmDumpTable (Table->Length, 0, Table, 0,
+                AcpiDmTableInfoFadt5);
+            if (ACPI_FAILURE (Status))
+            {
+                return;
+            }
         }
 
-        if (Table->Length <= FadtRevisionLength[i])
+        /* Check for FADT revision 6 fields and up (ACPI 6.0+) */
+
+        if (Table->Length > ACPI_FADT_V3_SIZE)
         {
-            break;  /* End of table */
+            Status = AcpiDmDumpTable (Table->Length, 0, Table, 0,
+                AcpiDmTableInfoFadt6);
+            if (ACPI_FAILURE (Status))
+            {
+                return;
+            }
         }
     }
 
-    /* Build a local FADT to test some FADT values */
+    /* Validate various fields in the FADT, including length */
 
     AcpiTbCreateLocalFadt (Table, Table->Length);
+
+    /* Validate FADT length against the revision */
+
+    AcpiDmValidateFadtLength (Table->Revision, Table->Length);
+}
+
+
+/*******************************************************************************
+ *
+ * FUNCTION:    AcpiDmValidateFadtLength
+ *
+ * PARAMETERS:  Revision            - FADT revision (Header->Revision)
+ *              Length              - FADT length (Header->Length
+ *
+ * RETURN:      None
+ *
+ * DESCRIPTION: Check the FADT revision against the expected table length for
+ *              that revision. Issue a warning if the length is not what was
+ *              expected. This seems to be such a common BIOS bug that the
+ *              FADT revision has been rendered virtually meaningless.
+ *
+ ******************************************************************************/
+
+static void
+AcpiDmValidateFadtLength (
+    UINT32                  Revision,
+    UINT32                  Length)
+{
+    UINT32                  ExpectedLength;
+
+
+    switch (Revision)
+    {
+    case 0:
+
+        AcpiOsPrintf ("// ACPI Warning: Invalid FADT revision: 0\n");
+        return;
+
+    case 1:
+
+        ExpectedLength = ACPI_FADT_V1_SIZE;
+        break;
+
+    case 2:
+
+        ExpectedLength = ACPI_FADT_V2_SIZE;
+        break;
+
+    case 3:
+    case 4:
+
+        ExpectedLength = ACPI_FADT_V3_SIZE;
+        break;
+
+    case 5:
+
+        ExpectedLength = ACPI_FADT_V5_SIZE;
+        break;
+
+    default:
+
+        return;
+    }
+
+    if (Length == ExpectedLength)
+    {
+        return;
+    }
+
+    AcpiOsPrintf (
+        "\n// ACPI Warning: FADT revision %X does not match length: "
+        "found %X expected %X\n",
+        Revision, Length, ExpectedLength);
 }
 
 
diff --git a/sys/contrib/dev/acpica/source/common/dmtbinfo.c b/sys/contrib/dev/acpica/source/common/dmtbinfo.c
index e0a6070..1cc37ef 100644
--- a/sys/contrib/dev/acpica/source/common/dmtbinfo.c
+++ b/sys/contrib/dev/acpica/source/common/dmtbinfo.c
@@ -400,7 +400,7 @@ ACPI_DMTABLE_INFO           AcpiDmTableInfoFacs[] =
  *
  ******************************************************************************/
 
-/* FADT version 1 (ACPI 1.0) */
+/* ACPI 1.0 FADT (Version 1) */
 
 ACPI_DMTABLE_INFO           AcpiDmTableInfoFadt1[] =
 {
@@ -486,7 +486,18 @@ ACPI_DMTABLE_INFO           AcpiDmTableInfoFadt1[] =
     ACPI_DMT_TERMINATOR
 };
 
-/* FADT version 3 (ACPI 2.0) */
+/* ACPI 1.0 MS Extensions (FADT version 2) */
+
+ACPI_DMTABLE_INFO           AcpiDmTableInfoFadt2[] =
+{
+    {ACPI_DMT_GAS,      ACPI_FADT_OFFSET (ResetRegister),           "Reset Register", 0},
+    {ACPI_DMT_UINT8,    ACPI_FADT_OFFSET (ResetValue),              "Value to cause reset", 0},
+    {ACPI_DMT_UINT16,   ACPI_FADT_OFFSET (ArmBootFlags),            "Reserved", 0},
+    {ACPI_DMT_UINT8,    ACPI_FADT_OFFSET (MinorRevision),           "Reserved", 0},
+    ACPI_DMT_TERMINATOR
+};
+
+/* ACPI 2.0+ Extensions (FADT version 3, 4, and 5) */
 
 ACPI_DMTABLE_INFO           AcpiDmTableInfoFadt3[] =
 {
@@ -510,23 +521,16 @@ ACPI_DMTABLE_INFO           AcpiDmTableInfoFadt3[] =
     ACPI_DMT_TERMINATOR
 };
 
-/* FADT version 4 (ACPI 3.0 and ACPI 4.0) */
-
-ACPI_DMTABLE_INFO           AcpiDmTableInfoFadt4[] =
-{
-    {ACPI_DMT_GAS,      ACPI_FADT_OFFSET (SleepControl),            "Sleep Control Register", 0},
-    ACPI_DMT_TERMINATOR
-};
-
-/* FADT version 5 (ACPI 5.0) */
+/* ACPI 5.0 Extensions (FADT version 5) */
 
 ACPI_DMTABLE_INFO           AcpiDmTableInfoFadt5[] =
 {
+    {ACPI_DMT_GAS,      ACPI_FADT_OFFSET (SleepControl),            "Sleep Control Register", 0},
     {ACPI_DMT_GAS,      ACPI_FADT_OFFSET (SleepStatus),             "Sleep Status Register", 0},
     ACPI_DMT_TERMINATOR
 };
 
-/* FADT version 6 (ACPI 6.0) */
+/* ACPI 6.0 Extensions (FADT version 6) */
 
 ACPI_DMTABLE_INFO           AcpiDmTableInfoFadt6[] =
 {
diff --git a/sys/contrib/dev/acpica/source/compiler/aslbtypes.c b/sys/contrib/dev/acpica/source/compiler/aslbtypes.c
index c956516..10ec3d4 100644
--- a/sys/contrib/dev/acpica/source/compiler/aslbtypes.c
+++ b/sys/contrib/dev/acpica/source/compiler/aslbtypes.c
@@ -151,7 +151,6 @@ AnMapArgTypeToBtype (
         return (ACPI_BTYPE_DATA | ACPI_BTYPE_DEBUG_OBJECT |
             ACPI_BTYPE_REFERENCE_OBJECT);
 
-    case ARGI_FIXED_TARGET:
     case ARGI_SIMPLE_TARGET:
 
         return (ACPI_BTYPE_OBJECTS_AND_REFS);
diff --git a/sys/contrib/dev/acpica/source/compiler/aslcompiler.l b/sys/contrib/dev/acpica/source/compiler/aslcompiler.l
index 15c9dae..228db8b 100644
--- a/sys/contrib/dev/acpica/source/compiler/aslcompiler.l
+++ b/sys/contrib/dev/acpica/source/compiler/aslcompiler.l
@@ -156,8 +156,14 @@ NamePathTail                [.]{NameSeg}
 "^="                        { count (3); return (PARSEOP_EXP_XOR_EQ); }
 "|="                        { count (3); return (PARSEOP_EXP_OR_EQ); }
 
-"["                         { count (3); return(PARSEOP_EXP_INDEX_LEFT); }
-"]"                         { count (0); return(PARSEOP_EXP_INDEX_RIGHT); }
+"["                         { count (3); return (PARSEOP_EXP_INDEX_LEFT); }
+"]"                         { count (0); return (PARSEOP_EXP_INDEX_RIGHT); }
+"("                         { count (0); return (PARSEOP_OPEN_PAREN); }
+")"                         { count (0); return (PARSEOP_CLOSE_PAREN); }
+
+"{"                         { count (0); return ('{'); }
+"}"                         { count (0); return ('}'); }
+","                         { count (0); return (','); }
 
 
     /*
@@ -691,12 +697,6 @@ NamePathTail                [.]{NameSeg}
 "__PATH__"                  { count (0); return (PARSEOP___PATH__); }
 
 
-"{"                         { count (0); return('{'); }
-"}"                         { count (0); return('}'); }
-","                         { count (0); return(','); }
-"("                         { count (0); return('('); }
-")"                         { count (0); return(')'); }
-
 {NameSeg}                   { char *s;
                                 count (0);
                                 s=UtStringCacheCalloc (ACPI_NAME_SIZE + 1);
diff --git a/sys/contrib/dev/acpica/source/compiler/aslcstyle.y b/sys/contrib/dev/acpica/source/compiler/aslcstyle.y
index fc7d593..d4034a5 100644
--- a/sys/contrib/dev/acpica/source/compiler/aslcstyle.y
+++ b/sys/contrib/dev/acpica/source/compiler/aslcstyle.y
@@ -149,21 +149,30 @@ Expression
 
     /* Parentheses */
 
-    | '(' TermArg ')'                   { $$ = $2;}
+    | PARSEOP_OPEN_PAREN
+        Expression
+        PARSEOP_CLOSE_PAREN             {$$ = $2;}
 
     /* Index term -- "= BUF1[5]" on right-hand side of an equals (source) */
 
-    | SuperName PARSEOP_EXP_INDEX_LEFT
-        TermArg PARSEOP_EXP_INDEX_RIGHT {$$ = TrCreateLeafNode (PARSEOP_INDEX);
-                                        TrLinkChildren ($$,3,$1,$3,TrCreateNullTarget ());}
+    | IndexExpTerm
     ;
 
-    /* Index term -- "BUF1[5] = " on left-hand side of an equals (target) */
-
+    /*
+     * Index term -- "BUF1[5] = " or " = BUF1[5] on either the left side
+     * of an equals (target) or the right side (source)
+     * Currently used in these terms:
+     *      Expression
+     *      ObjectTypeSource
+     *      DerefOfSource
+     *      Type6Opcode
+     */
 IndexExpTerm
 
-    : SuperName PARSEOP_EXP_INDEX_LEFT
-        TermArg PARSEOP_EXP_INDEX_RIGHT {$$ = TrCreateLeafNode (PARSEOP_INDEX);
+    : SuperName
+        PARSEOP_EXP_INDEX_LEFT
+        TermArg
+        PARSEOP_EXP_INDEX_RIGHT         {$$ = TrCreateLeafNode (PARSEOP_INDEX);
                                         TrLinkChildren ($$,3,$1,$3,TrCreateNullTarget ());}
     ;
 
@@ -177,11 +186,26 @@ IndexExpTerm
 
 EqualsTerm
 
+    /* Allow parens anywhere */
+
+    : PARSEOP_OPEN_PAREN
+        EqualsTerm
+        PARSEOP_CLOSE_PAREN             {$$ = $2;}
+
     /* Simple Store() operation */
 
-    : SuperName PARSEOP_EXP_EQUALS
+    | SuperName
+        PARSEOP_EXP_EQUALS
         TermArg                         {$$ = TrCreateAssignmentNode ($1, $3);}
 
+    /* Chained equals: (a=RefOf)=b, a=b=c=d etc. */
+
+    | PARSEOP_OPEN_PAREN
+        EqualsTerm
+        PARSEOP_CLOSE_PAREN
+        PARSEOP_EXP_EQUALS
+        TermArg                         {$$ = TrCreateAssignmentNode ($2, $5);}
+
     /* Compound assignments -- Add (operand, operand, target) */
 
     | TermArg PARSEOP_EXP_ADD_EQ        {$<n>$ = TrCreateLeafNode (PARSEOP_ADD);}
diff --git a/sys/contrib/dev/acpica/source/compiler/aslexternal.c b/sys/contrib/dev/acpica/source/compiler/aslexternal.c
index a814efd..8e76aa7 100644
--- a/sys/contrib/dev/acpica/source/compiler/aslexternal.c
+++ b/sys/contrib/dev/acpica/source/compiler/aslexternal.c
@@ -325,6 +325,7 @@ ExMoveExternals (
     ACPI_PARSE_OBJECT       *NextOp;
     ACPI_PARSE_OBJECT       *Prev;
     ACPI_PARSE_OBJECT       *Next;
+    char                    *ExternalName;
     ACPI_OBJECT_TYPE        ObjType;
     UINT32                  i;
 
@@ -345,6 +346,12 @@ ExMoveExternals (
          */
         ExternalOp = NextOp->Asl.Child;
 
+        /* Get/set the fully qualified name */
+
+        ExternalName = AcpiNsGetNormalizedPathname (ExternalOp->Asl.Node, TRUE);
+        ExternalOp->Asl.ExternalName = ExternalName;
+        ExternalOp->Asl.Namepath = ExternalName;
+
         /* Set line numbers (for listings, etc.) */
 
         ExternalOp->Asl.LineNumber = 0;
@@ -354,6 +361,14 @@ ExMoveExternals (
         Next->Asl.LineNumber = 0;
         Next->Asl.LogicalLineNumber = 0;
 
+        if (Next->Asl.ParseOpcode == PARSEOP_NAMESEG)
+        {
+            Next->Asl.ParseOpcode = PARSEOP_NAMESTRING;
+        }
+        Next->Asl.ExternalName = ExternalName;
+        UtInternalizeName (ExternalName, &Next->Asl.Value.String);
+        Next->Asl.AmlLength = strlen (Next->Asl.Value.String);
+
         Next = Next->Asl.Next;
         Next->Asl.LineNumber = 0;
         Next->Asl.LogicalLineNumber = 0;
diff --git a/sys/contrib/dev/acpica/source/compiler/aslkeywords.y b/sys/contrib/dev/acpica/source/compiler/aslkeywords.y
index 51af1c6..c908ae4 100644
--- a/sys/contrib/dev/acpica/source/compiler/aslkeywords.y
+++ b/sys/contrib/dev/acpica/source/compiler/aslkeywords.y
@@ -58,15 +58,18 @@ AccessAttribKeyword
     | PARSEOP_ACCESSATTRIB_SND_RCV          {$$ = TrCreateLeafNode (PARSEOP_ACCESSATTRIB_SND_RCV);}
     | PARSEOP_ACCESSATTRIB_WORD             {$$ = TrCreateLeafNode (PARSEOP_ACCESSATTRIB_WORD);}
     | PARSEOP_ACCESSATTRIB_WORD_CALL        {$$ = TrCreateLeafNode (PARSEOP_ACCESSATTRIB_WORD_CALL);}
-    | PARSEOP_ACCESSATTRIB_MULTIBYTE '('    {$<n>$ = TrCreateLeafNode (PARSEOP_ACCESSATTRIB_MULTIBYTE);}
+    | PARSEOP_ACCESSATTRIB_MULTIBYTE
+        PARSEOP_OPEN_PAREN                  {$<n>$ = TrCreateLeafNode (PARSEOP_ACCESSATTRIB_MULTIBYTE);}
         ByteConst
-        ')'                                 {$$ = TrLinkChildren ($<n>3,1,$4);}
-    | PARSEOP_ACCESSATTRIB_RAW_BYTES '('    {$<n>$ = TrCreateLeafNode (PARSEOP_ACCESSATTRIB_RAW_BYTES);}
+        PARSEOP_CLOSE_PAREN                 {$$ = TrLinkChildren ($<n>3,1,$4);}
+    | PARSEOP_ACCESSATTRIB_RAW_BYTES
+        PARSEOP_OPEN_PAREN                  {$<n>$ = TrCreateLeafNode (PARSEOP_ACCESSATTRIB_RAW_BYTES);}
         ByteConst
-        ')'                                 {$$ = TrLinkChildren ($<n>3,1,$4);}
-    | PARSEOP_ACCESSATTRIB_RAW_PROCESS '('  {$<n>$ = TrCreateLeafNode (PARSEOP_ACCESSATTRIB_RAW_PROCESS);}
+        PARSEOP_CLOSE_PAREN                 {$$ = TrLinkChildren ($<n>3,1,$4);}
+    | PARSEOP_ACCESSATTRIB_RAW_PROCESS
+        PARSEOP_OPEN_PAREN                  {$<n>$ = TrCreateLeafNode (PARSEOP_ACCESSATTRIB_RAW_PROCESS);}
         ByteConst
-        ')'                                 {$$ = TrLinkChildren ($<n>3,1,$4);}
+        PARSEOP_CLOSE_PAREN                 {$$ = TrLinkChildren ($<n>3,1,$4);}
     ;
 
 AccessTypeKeyword
diff --git a/sys/contrib/dev/acpica/source/compiler/aslopcodes.c b/sys/contrib/dev/acpica/source/compiler/aslopcodes.c
index de9ffe1..c981f07 100644
--- a/sys/contrib/dev/acpica/source/compiler/aslopcodes.c
+++ b/sys/contrib/dev/acpica/source/compiler/aslopcodes.c
@@ -289,7 +289,7 @@ OpcSetOptimalIntegerSize (
         Op->Asl.AmlOpcode = AML_DWORD_OP;
         return (4);
     }
-    else
+    else /* 64-bit integer */
     {
         if (AcpiGbl_IntegerByteWidth == 4)
         {
@@ -299,8 +299,12 @@ OpcSetOptimalIntegerSize (
             if (!Gbl_IgnoreErrors)
             {
                 /* Truncate the integer to 32-bit */
-                Op->Asl.AmlOpcode = AML_DWORD_OP;
-                return (4);
+
+                Op->Asl.Value.Integer &= ACPI_UINT32_MAX;
+
+                /* Now set the optimal integer size */
+
+                return (OpcSetOptimalIntegerSize (Op));
             }
         }
 
